<?php
/**
 * @package Freestyle Joomla
 * @author Freestyle Joomla
 * @copyright (C) 2013 Freestyle Joomla
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
defined('_JEXEC') or die;

JFormHelper::loadFieldClass('text');

class JFormFieldFSJNoticeSeen extends JFormField
{
	protected $type = 'FSJNoticeSeen';
	static $counts;
	
	protected function getInput()
	{
		$notice_id = $this->form->getValue('id');
		if ($notice_id < 1)
			return "Please save your notice first";
	
		$output[] = "<p>".JText::sprintf("FSJ_NOTICES_SEEN_COUNT" ,"<span id='closed_count' style='font-weight:bold;'>" . $this->form->getValue('seen') . "</span>") . "&nbsp;&nbsp;";
		$output[] = "<span id='reset_status'></span>";
		$output[] = "&nbsp;<div class='btn' onclick='fsj_notice_reset({$notice_id});'>Reset</div>";
		$output[] = "&nbsp;<a class='btn fsj_show_modal_iframe' data_modal_width='880' href='" . JRoute::_("index.php?option=com_fsj_notices&view=userlist&tmpl=component&noticeid=" . $notice_id ) . "'>Show Users</a>";		
		
		$output[] = "</p><p>Please Note: This includes both registered and unregistered users</p>";
		
		$js = "function fsj_notice_reset(id) { 
			var url = '" . JRoute::_('index.php?option=com_fsj_notices&task=reset.notice', false) . "';
			url += '&notice=' + id;
			jQuery('#reset_status').html('Resetting...');
			jQuery('#closed_count').html('0');
			jQuery.get(url, function() {
				jQuery('#reset_status').html('Done');
			})
			.fail(function() { //alert('error'); 
			});
		};";
		
		$document = JFactory::getDocument();
		$document->addScriptDeclaration("\n\n\n".$js."\n\n\n");
		
		return implode($output);
	}	
}
