<?php
/**
 * @package Freestyle Joomla
 * @author Freestyle Joomla
 * @copyright (C) 2013 Freestyle Joomla
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');

require_once JPATH_COMPONENT_ADMINISTRATOR.'/helpers/fsj_notices.php';


class fsj_noticesModelnotice extends JModelAdmin
{
	protected $text_prefix = 'fsj_notices_notice';

	protected function canDelete($record)
	{
		$user = JFactory::getUser();
		return $user->authorise('core.delete', 'com_fsj_notices');
	}

	protected function canEditState($record)
	{
		return parent::canEditState('com_fsj_notices');
	}

	protected function prepareTable($table)
	{
		$db = $this->getDbo();

		// Set the publish date to now
		if($table->state == 1 && intval($table->publish_up) == 0) {
			//$table->publish_up = JFactory::getDate()->toSql();
		}


		// Reorder the articles within the category so the new article is first
		/*if (empty($table->id)) {
			$table->reorder('catid = '.(int) $table->catid.' AND state >= 0');
		}*/
	}

	public function getTable($type = 'notice', $prefix = 'JTablefsj_notices', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	public function getItem($pk = null)
	{
		if ($item = parent::getItem($pk)) {

	JTable::addIncludePath(JPATH_LIBRARIES.DS.'fsj_core'.DS.'tables');
			$setting = JTable::getInstance('FSJSettings', 'JTable');
			$setting->loadByJAsset($item->asset_id);
			$params = json_decode($setting->value, true);

				if (is_array($params) && array_key_exists('notices_data_time', $params))
			{
				$item->notices_data_time = $params['notices_data_time'];
			} else {
				$item->notices_data_time = array();
			}
				if (is_array($params) && array_key_exists('notices_user', $params))
			{
				$item->notices_user = $params['notices_user'];
			} else {
				$item->notices_user = array();
			}
				if (is_array($params) && array_key_exists('notices_options', $params))
			{
				$item->notices_options = $params['notices_options'];
			} else {
				$item->notices_options = array();
			}
				if (is_array($params) && array_key_exists('notices_misc', $params))
			{
				$item->notices_misc = $params['notices_misc'];
			} else {
				$item->notices_misc = array();
			}
				if (is_array($params) && array_key_exists('notices_class', $params))
			{
				$item->notices_class = $params['notices_class'];
			} else {
				$item->notices_class = array();
			}
				if (is_array($params) && array_key_exists('notices_inpage_options', $params))
			{
				$item->notices_inpage_options = $params['notices_inpage_options'];
			} else {
				$item->notices_inpage_options = array();
			}
				if (is_array($params) && array_key_exists('notices_overlay_options', $params))
			{
				$item->notices_overlay_options = $params['notices_overlay_options'];
			} else {
				$item->notices_overlay_options = array();
			}
				if (is_array($params) && array_key_exists('notices_menu', $params))
			{
				$item->notices_menu = $params['notices_menu'];
			} else {
				$item->notices_menu = array();
			}
				if (is_array($params) && array_key_exists('notices_template', $params))
			{
				$item->notices_template = $params['notices_template'];
			} else {
				$item->notices_template = array();
			}
	
									
		}
		

	
		return $item;
	}

	public function getForm($data = array(), $loadData = true)
	{
	
		// Get the form.
		$form = $this->loadForm('fsj_notices.notice', 'notice', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}
		$jinput = JFactory::getApplication()->input;

		// The front end calls this model and uses a_id to avoid id clashes so we need to check for that first.
		if ($jinput->get('a_id'))
		{
			$id =  $jinput->get('a_id', 0);
		}
		// The back end uses id so we use that the rest of the time and set it to 0 by default.
		else
		{
			$id =  $jinput->get('id', 0);
		}

		// Determine correct permissions to check.
		/*if ($this->getState('article.id'))
		{
			$id = $this->getState('article.id');
			// Existing record. Can only edit in selected categories.
			$form->setFieldAttribute('catid', 'action', 'core.edit');
			// Existing record. Can only edit own articles in selected categories.
			$form->setFieldAttribute('catid', 'action', 'core.edit.own');
		}
		else
		{
			// New record. Can only create in selected categories.
			$form->setFieldAttribute('catid', 'action', 'core.create');
		}*/

		$user = JFactory::getUser();

		// Check for existing article.
		// Modify the form based on Edit State access controls.
		/*if ($id != 0 && (!$user->authorise('core.edit.state', 'com_fsj_notices.article.'.(int) $id))
		|| ($id == 0 && !$user->authorise('core.edit.state', 'com_fsj_notices'))
		)
		{
			// Disable fields for display.
			$form->setFieldAttribute('featured', 'disabled', 'true');
			$form->setFieldAttribute('ordering', 'disabled', 'true');
			$form->setFieldAttribute('publish_up', 'disabled', 'true');
			$form->setFieldAttribute('publish_down', 'disabled', 'true');
			$form->setFieldAttribute('state', 'disabled', 'true');

			// Disable fields while saving.
			// The controller has already verified this is an article you can edit.
			$form->setFieldAttribute('featured', 'filter', 'unset');
			$form->setFieldAttribute('ordering', 'filter', 'unset');
			$form->setFieldAttribute('publish_up', 'filter', 'unset');
			$form->setFieldAttribute('publish_down', 'filter', 'unset');
			$form->setFieldAttribute('state', 'filter', 'unset');
		}*/

		return $form;
	}

	protected function loadFormData()
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_fsj_notices.edit.notice.data', array());

		if (empty($data)) {
			$data = $this->getItem();

			// Prime some default values.
			if ($this->getState('notice.id') == 0) {
				$app = JFactory::getApplication();
				
				// need to load the state of any filters in
				$data->set('type', JRequest::getInt('type', $app->getUserState('com_fsj_notices.notices.filter.type')));
				$data->set('position_id', JRequest::getInt('position_id', $app->getUserState('com_fsj_notices.notices.filter.position_id')));

													// if set_id and no value is found, then we need to lookup the default one from the table
			}
		}

		return $data;
	}

	public function save($data)
	{
		$db = JFactory::getDBO();


																																															

/* PARENT SAVE CODE */
		// Initialise variables;
		$dispatcher = JDispatcher::getInstance();
		$table = $this->getTable();
		$key = $table->getKeyName();
		$pk = (!empty($data[$key])) ? $data[$key] : (int) $this->getState($this->getName() . '.id');
		$isNew = true;

		// Include the content plugins for the on save events.
		JPluginHelper::importPlugin('content');

		// Allow an exception to be thrown.
		try
		{
			// Load the row if saving an existing record.
			if ($pk > 0)
			{
				$table->load($pk);
				$isNew = false;
			}


			// Bind the data.
			if (!$table->bind($data))
			{
				$this->setError($table->getError());
				return false;
			}

		
			
				FSJ_Settings::LoadBaseSettings("com_fsj_notices");
				if (FSJ_Settings::Get('notices_reset', 'onsave'))
				{
							$table->reset = (int)$table->reset + 1;
				}
			
		
			// Prepare the row for saving
			$this->prepareTable($table);

			// Check the data.
			if (!$table->check())
			{
				$this->setError($table->getError());
				return false;
			}

			// Trigger the onContentBeforeSave event.
			$result = $dispatcher->trigger($this->event_before_save, array($this->option . '.' . $this->name, &$table, $isNew));
			if (in_array(false, $result, true))
			{
				$this->setError($table->getError());
				return false;
			}

			// Store the data.
			if (!$table->store())
			{
				$this->setError($table->getError());
				return false;
			}



			// Clean the cache.
			$this->cleanCache();

			// Trigger the onContentAfterSave event.
			$dispatcher->trigger($this->event_after_save, array($this->option . '.' . $this->name, &$table, $isNew));
		}
		catch (Exception $e)
		{
			$this->setError($e->getMessage());

			return false;
		}

		$pkName = $table->getKeyName();

		if (isset($table->$pkName))
		{
			$this->setState($this->getName() . '.id', $table->$pkName);
		}
		$this->setState($this->getName() . '.new', $isNew);
		
/* END PARENT SAVE CODE */

																																															

		
			
						if (isset($table->id) && FSJ_Settings::Get('notices_reset', 'onsave'))
						{
								$qry = "DELETE FROM #__fsj_notices_notice_seen WHERE notice_id = " . $table->id;
								$db->setQuery($qry);
								$db->query();
						}
			
		
		return true;
	}

	protected function getReorderConditions($table)
	{
		$condition = array();
				return $condition;
	}

	protected function cleanCache($group = null, $client_id = 0)
	{
		/*parent::cleanCache('com_fsj_notices');
		parent::cleanCache('mod_articles_archive');
		parent::cleanCache('mod_articles_categories');
		parent::cleanCache('mod_articles_category');
		parent::cleanCache('mod_articles_latest');
		parent::cleanCache('mod_articles_news');
		parent::cleanCache('mod_articles_popular');*/
	}
	
	public function canSave($data = array(), $key = 'id')
	{
		return JFactory::getUser()->authorise('core.edit', $this->option);
	}
	



	static function allowEdit($faq)
	{
		$user     = JFactory::getUser();
		$userId   = $user->get('id');
		$asset    = 'com_fsj_notices.notices_notice.' . $faq->id;

		// Check general edit permission first.
		if ($user->authorise('core.edit', $asset))
		{
			return true;
		}

		// Fallback on edit.own.
		// First test if the permission is available.
		if ($user->authorise('core.edit.own', $asset))
		{
			// If the owner matches 'me' then do the test.
			if ($faq->created_by == $userId)
			{
				return true;
			}
		}

		return false;
	}

	static function allowState($faq)
	{
		$user     = JFactory::getUser();
		$userId   = $user->get('id');
		$asset    = 'com_fsj_notices.notices_notice.' . $faq->id;

		// Check general edit permission first.
		if ($user->authorise('core.edit.state', $asset))
		{
			return true;
		}

		return false;
	}
}
