<?php
/**
 * @package Freestyle Joomla
 * @author Freestyle Joomla
 * @copyright (C) 2013 Freestyle Joomla
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

class fsj_noticesViewuserlist extends JViewLegacy
{

	public function display($tpl = null)
	{
		JHtml::_('behavior.modal');
		
		$this->what = JRequest::getVar('what');
		$this->noticeid = JRequest::getInt("noticeid");
		
		if ($this->what == "contact")
			return $this->ContactForm();
			
		if ($this->what == "send")
			return $this->sendEMail();
	
		$this->search = JRequest::getVar('search');
		$this->usergroup = JRequest::getInt('usergroup');	
		$this->limitstart = JRequest::getInt('limitstart');
		$this->seen = JRequest::getInt('seen');
		$this->limit = JFactory::getApplication()->getUserStateFromRequest('users.limit', 'limit', 10, 'int');
	
		$this->getData();
		$this->getGroupSelect();
		$this->getSeenSelect();
		$this->pagination = new JPagination($this->maxitems, $this->limitstart, $this->limit );
		
		parent::display();
	}
	
	function getData()
	{
		$db	= JFactory::getDBO();
		$qry = "SELECT * FROM #__users as u ";
		$qry .= " LEFT JOIN (SELECT *, 1 as seen FROM #__fsj_notices_notice_seen WHERE notice_id = '" . $db->escape($this->noticeid) . "') as s ON u.id = s.user_id ";
				
		$where = array();
		
		if ($this->search != "")
		{
			$search_parts = array();
			$search_parts[] = "username LIKE '%".$db->escape($this->search)."%'";
			$search_parts[] = "name LIKE '%".$db->escape($this->search)."%'";
			$search_parts[] = "email LIKE '%".$db->escape($this->search)."%'";
			
			$where[] = "( " . implode(" OR ", $search_parts) . " )";
		}
		
		if ($this->seen == 1)
		{
			$where[] = " s.seen = 1 ";	
		} else if ($this->seen == -1)
		{
			$where[] =  " s.seen IS NULL ";	
		}

		if ($this->usergroup > 0)
		{
			$where[] = "id IN (SELECT user_id FROM #__user_usergroup_map WHERE group_id = " . $db->escape($this->usergroup) . ")";
		}
		
		// add where
		if (count($where) > 0)
		{
			$qry .= " WHERE " . implode(" AND ", $where);	
		}
		
		//echo $qry . "<br>";
		$db->setQuery( $qry );
		$db->query();
		$this->maxitems = $db->getNumRows();	
		
		$db->setQuery( $qry, $this->limitstart, $this->limit );
		$this->items = $db->loadObjectList();
	}
	
	function getGroupSelect()
	{
		$db	= JFactory::getDBO();

		// load in joomla user groups
		$qry = "SELECT * FROM #__usergroups ORDER BY lft";
		$db->setQuery($qry);
		
		$this->groups = $db->loadObjectList();
		
		$group_index = array();
		
		foreach ($this->groups as &$group)
		{
			$group_index[$group->id] = &$group;
			
			if ($group->parent_id == 0)
			{
				$group->level = 0;	
			} else {
				$group->level = $group_index[$group->parent_id]->level + 1;
			}
			
			$group->display = str_repeat("- ", $group->level) . $group->title;
		}
		
		array_unshift($this->groups, JHTML::_('select.option', '', JText::_("FSJ_NOTICES_JOOMLA_USERGROUP"), 'id', 'display'));
		$this->jgroup_select = JHTML::_('select.genericlist',  $this->groups, 'usergroup', 'class="inputbox" size="1" onchange="Joomla.submitform();"', 'id', 'display', $this->usergroup);	
	}
	
	function getSeenSelect()
	{
		$seen = array();
		$seen[] = JHTML::_('select.option', '0', JText::_("FSJ_NOTICES_SEEN_STATUS"), 'id', 'display');
		$seen[] = JHTML::_('select.option', '1', JText::_("FSJ_NOTICES_SEEN_SEEN"), 'id', 'display');
		$seen[] = JHTML::_('select.option', '-1', JText::_("FSJ_NOTICES_SEEN_UNSEEN"), 'id', 'display');
		$this->seen_select = JHTML::_('select.genericlist',  $seen, 'seen', 'class="inputbox" size="1" onchange="Joomla.submitform();"', 'id', 'display', $this->seen);	
	}
	
	function ContactForm()
	{
		$ids = JRequest::getVar('cid', array(), 'array');
		$this->users = array();
		
		foreach ($ids as $id)
			$this->users[] = JFactory::getUser($id);

		$this->emails = array();
		
		foreach ($this->users as $user)
		{
			$this->emails[] = $user->name . " (" . $user->email . ")";
		}

		$this->idlist = implode("|", $ids);
		
		$db = JFactory::getDBO();
		$qry = " SELECT * FROM #__fsj_notices_notice WHERE id = '" . $db->escape($this->noticeid) . "'";
		$db->setQuery($qry);
		
		$this->notice = $db->loadObject();
		
		parent::display("contact");
	}
	
	function sendEMail()
	{
		print_p($_POST);
		print_p($_GET);
		exit;	
	}
}
