<?php
/**
 * @package Freestyle Joomla
 * @author Freestyle Joomla
 * @copyright (C) 2013 Freestyle Joomla
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
defined('_JEXEC') or die;
jimport( 'fsj_core.lib.utils.template');
jimport( 'fsj_core.lib.utils.parser');

require_once(JPATH_SITE.DS."components".DS."com_fsj_notices".DS."helper".DS."notice_check.php");

class FSJ_Notices {
	
	static $js_done = false;
	static $seendata = false;
	static $positions = array();
	var $overlay = array();
	
	function Display($position, $show_output = true, $template_id = "", $notice_id = "", $single_random = false)
	{
		FSJ_Page::StylesAndJS();

		//echo "Display($position, $show_output, $template_id, $notice_id, $single_random)<br>";
		$this->user = JFactory::getUser();
		FSJ_Settings::LoadBaseSettings("com_fsj_notices");

		$show_notices = $this->GetNotices($position, $notice_id, $single_random);
		
		if (!$show_notices || count($show_notices) == 0)
			return false;

		$need_seen_js = false;
		$count = 0;
				
		$output = array();
				
		$seen = $this->getSeen($show_notices);

		foreach ($show_notices as $notice)
		{
			if ($this->hasSeen($seen, $notice))
			{
				if (FSJ_Settings::Get('notices_debug', 'enable'))
				{
					if ($notice->display)
					{
						$notice->display = false;
						$notice->reason = "You have already closed this notice";	
					}	
				} else {
					continue;
				}
			}

			if ($notice->asset_id < 1)
				print_p($notice);

			FSJ_Settings::AddItemSettings($notice->asset_id);

			$tid = FSJ_Settings::Get('notices_template', 'template', $notice->asset_id, false);	
			
			//echo "Tempalte : $tid / $template_id<br>";
			
			if ($template_id != "")
				$tid = $template_id;
			
			if ($notice->display)
			{
				
				$this->template = new FSJ_Template();		
				$this->template->load_template("notices", "notices", $tid);

				$showtitle = $this->getSetting($notice, "notices_options", "showtitle");
				$canclose = $this->getSetting($notice, "notices_options", "canclose");
				$remember = $this->getSetting($notice, "notices_options", "remember");
				
				$this->template->assign('show_title', $showtitle);
				$this->template->assign("title", $notice->title);
				$this->template->assign("message", $notice->description);
				$this->template->assign("id", $notice->id);
				
				/* defaults */
				$this->template->assign("closejs", '');
				$this->template->assign("show_close", false);
				$this->template->assign('show_image', false);
				$this->template->assign('image_url', '');
				$this->template->assign("style", '');		
				$this->template->assign("confirm_text", '');
				$this->template->assign('show_confirm', false);
				
				if ($canclose)
				{
					$js = "fsj_notice_hide({$notice->id});";
					if ($remember)
					{
						$js = "fsj_notice_seen({$notice->id});";
						$need_seen_js = true;
					}
					$this->template->assign("closejs", $js);
					$this->template->assign("show_close", true);
				}
				
				if ($notice->image)
				{
					$this->template->assign('show_image', true);
					$this->template->assign('image_url', JURI::root() . "images/" . $notice->image);
				}
				
				$notice->class = "";
				if (isset($notice->settings->notices_class->class))
					$notice->class = $notice->settings->notices_class->class;
				
				$notice->class = str_replace("alert-", "", $notice->class);
				
				$this->template->assign("class", $notice->class);
				
				$style = "";

				if (isset($notice->settings->notices_checkbox->checkbox) && $notice->settings->notices_checkbox->checkbox)
				{
					if (!isset($notice->settings->notices_checkbox->checkbox_text)) 
						$notice->settings->notices_checkbox->checkbox_text = "";
					
					$this->template->assign("confirm_text", $notice->settings->notices_checkbox->checkbox_text);
					$this->template->assign('show_confirm', true);
				}
				
				$parsed = $this->template->fetch("fsjtpl:notices.notices.$tid.main");
			} else {
				$parsed = "<div class='alert alert-error'><h4>NOT DISPLAYING: {$notice->title} ({$notice->alias})</h4><strong>Reason:</strong> " . $notice->reason . "</div>";	
			}

			$parser = new FSJParser();
			$parser->AddCommonVars();
			$parsed = $parser->Parse($parsed);

			$output[] = "<div class='fsjtpl_notices_notices_{$tid} fsj_notice_{$notice->id}'>";
			$output[] = $parsed;
			$output[] = "</div>";
			
			if ($notice->type == 1)
			{
				
				if (!isset($notice->settings->notices_overlay_options->width))
					$notice->settings->notices_overlay_options->width = "400px";
					
				$style = "style='width: " . $notice->settings->notices_overlay_options->width . ";'";
					
				$olclass = "overlay";
				if ($notice->settings->notices_overlay_options->position == "start")
					$olclass = "start";
				
				$this->overlay[$notice->settings->notices_overlay_options->position][] =
					"<div class='fsjtpl_notices_notices_{$tid} fsj_notice_{$notice->id}' $style><div class='$olclass'>" . $parsed . "</div></div>";
			}
			$count++;
			
			if (isset($this->template))
				$this->template->OutputCSS("notices", "notices", $tid);
		}
		
		if ($count && $show_output)
		{
			echo implode($output);
			$this->OutputJS();
		}
		
		//foreach ($used_templates as $tid)
			

		return $count;	
	}	
	
	function getSetting($notice, $group, $option)
	{
		if (isset($notice->settings->$group->$option))
			return $notice->settings->$group->$option;
		
		return FSJ_Settings::Get($group, $option);
	}
	
	function OutputJS()
	{
		if (FSJ_Notices::$js_done)
			return;
		
		$js = " 
		function fsj_notice_seen(id) { 
			if (!fjs_notice_check(id))
				return false;
			var url = '" . JRoute::_('index.php?option=com_fsj_notices&controller=notice&task=close', false) . "';
			url += '&notice=' + id;
			url += '&time=' + new Date().getTime();
			jQuery.get(url);
			jQuery('div.fsj_notice_' + id).hide();
		};
		
		function fsj_notice_hide(id) {
			if (!fjs_notice_check(id))
				return false;
			jQuery('div.fsj_notice_' + id).hide();
		}
		
		function fjs_notice_check(id)
		{
			if (jQuery('#fsj_notice_confirm_' + id).length == 0)
				return true;
				
			if (jQuery('#fsj_notice_confirm_' + id).prop('checked'))
				return true;

			jQuery('#fsj_notice_confirm_div_' + id).stop();
			
			for(i=0;i<3;i++) {
				jQuery('#fsj_notice_confirm_div_' + id).fadeTo(300, 0.3).fadeTo(300, 1.0);
			}
			return false;
		}
		
		jQuery(document).ready( function () {
			fsj_notices_align();
		});
		
		function fsj_notices_align()
		{
			fsj_notices_align_horiz('div.fsj_notices_overlay.n_top > div');
			fsj_notices_align_horiz('div.fsj_notices_overlay.n_center > div');
			fsj_notices_align_horiz('div.fsj_notices_overlay.n_bottom > div');
			fsj_notices_align_horiz('div.fsj_notices_start > div');
			
			fsj_notices_align_vert('div.fsj_notices_overlay.n_left > div');
			fsj_notices_align_vert('div.fsj_notices_overlay.n_center > div');
			fsj_notices_align_vert('div.fsj_notices_overlay.n_right > div');
		}
		
		function fsj_notices_align_horiz(match)
		{
			jQuery(match).each(function () {
				var width = parseInt(jQuery(this).outerWidth() / 2);
				jQuery(this).css('margin-left', '-' + width + 'px');
			});
		}	
				
		function fsj_notices_align_vert(match)
		{
			jQuery(match).each(function () {
				var height = parseInt(jQuery(this).outerHeight() / 2);
				jQuery(this).css('margin-top', '-' + height + 'px');
			});
		}	
		";
		$document = JFactory::getDocument();
		$document->addScriptDeclaration("\n\n\n".$js."\n\n\n");
		
		FSJ_Notices::$js_done = true;
	}
	
	function hasSeen($seen, $notice)
	{
		if (is_array($seen) && array_key_exists($notice->id, $seen))
			return true;
		
		$app = JFactory::getApplication();
		$session_seen = $app->getUserState( "fsj_notices.seen_".$notice->id."_".$notice->reset, 0);

		if ($session_seen)
		{
			if ($this->user->id > 0)
			{
				// seen in session, insert into notice seen table and return false
				$db = JFactory::getDBO();
				$qry = "REPLACE INTO #__fsj_notices_notice_seen (notice_id, user_id) VALUES (" . $notice->id . ", " . $this->user->id . ")";
				$db->setQuery($qry);
				$db->Query();
			}
			
			return true;	
		}
		return false;	
	}
		
	function getSeen($notices)
	{
		if ($this->user->id < 1)
			return array();
		
		$seen = array();
		if (!is_array(FSJ_Notices::$seendata))
		{
			$db = JFactory::getDBO();
			$qry = "SELECT notice_id FROM #__fsj_notices_notice_seen WHERE user_id = " . $db->escape($this->user->id);
			$db->setQuery($qry);
			FSJ_Notices::$seendata = $db->loadObjectList('notice_id');
			if (!FSJ_Notices::$seendata)
			{
				FSJ_Notices::$seendata = array();
			}
		}
		
		return FSJ_Notices::$seendata;
	}
	
	function getNotices($position, $notice_id = 0, $single_random = false)
	{		
		$db = JFactory::getDBO();

		if (!is_numeric($position))
			$position = $this->lookupPosition($position);
		
		$using_alias = false;
		
		if (!is_numeric($notice_id) && $notice_id != "")
			$using_alias = true;
		
		if ($notice_id > 0)
			$position = "";
		
		$pos_key = $position;
		if ($position == "")
			$pos_key = "-";
		
		$pos_key .= "-".$notice_id."-".$single_random;
		
		if (isset(FSJ_Notices::$positions[$pos_key]))
			return FSJ_Notices::$positions[$pos_key];
			
		$query = $db->getQuery(true);
		$query->select("*")
			->from("#__fsj_notices_notice");	
			
		if ($position == -1)
		{
			$query->where("type = 1");
		} else {
			$query->where("type = 0");
			if ($position > 0)
			{
				$query->where("position_id = " . $db->escape($position));
			} 
		}
		$query->where("state = 1");


		if ($notice_id > 0)
			$query->where("id = " . $db->escape($notice_id));
		else if ($using_alias)
			$query->where("alias = '" . $db->escape($notice_id) . "'");

		$query->order("ordering");
		
		//echo $query . "<br>";
		$db->setQuery($query);

		$items = $db->loadObjectList();

		if (!count($items))
			return null;
		
		$id_map = array();	
		$extra_settings_ids = array();
		
		foreach ($items as $item)
		{
			$id_map[$item->asset_id] = $item;
			$extra_settings_ids[] = $item->asset_id;		
		}
		
		$query2 = $db->getQuery(true);
		$query2->select("*")
			->from("#__fsj_main_settings")
			->where("j_asset IN (" . implode(", ", $extra_settings_ids) . ")");
		$db->setQuery($query2);

		$settings = $db->loadObjectList();
		
		foreach ($settings as $setting)
			$id_map[$setting->j_asset]->settings = json_decode($setting->value);

		
		FSJ_Notices::$positions[$pos_key] = array();
		foreach ($items as $notice)
		{
			$notice->display = true;
			if (!FSJ_NoticesCheck::ShouldDisplay($notice))
			{
				$notice->display = false;
				if (FSJ_Settings::Get('notices_debug', 'enable'))
				{
					//print_p($notice);	
				} else {
					continue;
				}
			}	
			
			//FSJ_NoticesCheck::ShouldDisplay($notice);
			
			FSJ_Notices::$positions[$pos_key][] = $notice;
		}
		
		
		if ($single_random)
		{
			if (FSJ_Settings::Get('notices_debug', 'enable'))
			{
				echo "<p class='text text-info'><strong>Freestyle Notices will display 1 random notice out of the following notices. Non displayed notices will be ignored.</strong></p>";
			} else {
				if (count(FSJ_Notices::$positions[$pos_key]) > 1)
				{
					$notice_offset = array_rand(FSJ_Notices::$positions[$pos_key]);
					$notice = FSJ_Notices::$positions[$pos_key][$notice_offset];
					FSJ_Notices::$positions[$pos_key] = array();
					FSJ_Notices::$positions[$pos_key][] = $notice;
				}
			}
		}

		return FSJ_Notices::$positions[$pos_key];
	}

	function lookupPosition($pos)
	{
		if (trim($pos) == "")
			return 0;
		
		if ($pos == "overlay")
			return -1;
		
		if ($pos > 0)
			return $pos;
		
		$db = JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__fsj_notices_position WHERE alias = '" . $db->escape($pos) . "'");
		$position = $db->loadObject();
		if ($position)
			return $position->id;
		
		return 0;
	}
}