<?php
/**
 * @package Freestyle Joomla
 * @author Freestyle Joomla
 * @copyright (C) 2013 Freestyle Joomla
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/
defined('_JEXEC') or die;

jimport('fsj_core.lib.utils.general');
jimport('fsj_core.lib.utils.plugin_handler');

class plgSystemFSJ_Notices extends JPlugin
{	
	public function __construct(&$subject, $config = array())
	{
		parent::__construct($subject, $config);
		if (JFactory::getApplication()->isAdmin())
			return true;
	}
	
	public function onAfterDispatch()
	{
		if (JFactory::getApplication()->isAdmin())
			return true;

		$tmpl = JRequest::getVar('tmpl');
		if ($tmpl == "component")
			return true;

		$tmpl = JRequest::getVar('format');
		if ($tmpl == "raw")
			return true;
		
		$lib_file = JPATH_SITE.DS.'components'.DS.'com_fsj_notices'.DS.'helper'.DS.'notices.php';
		
		if (!file_exists($lib_file))
			return true;
		
		require_once($lib_file);

		FSJ_Settings::LoadBaseSettings("com_fsj_notices");
		$this->template_id = FSJ_Settings::Get('notices_template', 'template', 'com_fsj_notices');
		//echo "BASE TEMAPLTE ID : " . $this->template_id . "<br>";
		
		//print_p(FSJ_Settings::$loaded);
		
		$this->notices = new FSJ_Notices();
		$this->showcount = $this->notices->Display("overlay", false, "");//$this->template_id);

		if (!$this->showcount)
			return true;
		
		// need to include js stuff for notices
		FSJ_Settings::LoadBaseSettings("com_fsj_notices");
		FSJ_Page::Style("components/com_fsj_notices/assets/css/fsj_notices.less");
		$this->notices->OutputJS();
		
		return true;
	}
	
	public function onAfterRender()
	{
		if (JFactory::getApplication()->isAdmin())
			return true;
		
		$tmpl = JRequest::getVar('tmpl');
		if ($tmpl == "component")
			return true;
		
		if (!$this->showcount)
			return true;

		$response = JResponse::getBody();
		$bclose = strpos($response, "</body>");
		$bopen = strpos($response, "<body");
		if ($bopen > 0)
		{
			$bopen = strpos($response, ">", $bopen) + 1;
		}
		
		$notice_text = array();
		$prefix_text = array();
		foreach ($this->notices->overlay as $pos => $notices)
		{
			if ($pos == "start")
			{
				$prefix_text[] = "<div class='fsj'><div class='fsj_notices_start'>";
				$prefix_text[] = implode($notices);
				$prefix_text[] = "</div></div>";
			} else {
				// add all notices to "Center" position
				$notice_text[] = "<div class='fsj'><div class='fsj_notices_overlay n_$pos'>";
				$notice_text[] = implode($notices);
				$notice_text[] = "</div></div>";
			}
		}
		
		if ($bclose > 0 && $bopen > 0)
		{
			$response = 
				substr($response, 0, $bopen) .
				implode($prefix_text) . "\n" . 
				substr($response, $bopen, $bclose) . 
				implode($notice_text) . "\n" . 
				substr($response, $bclose);
		} else {
			$response .= implode($notice_text);
		}
		
		JResponse::setBody($response);
		
		return true;
	}
}
